import { Server, CustomTransportStrategy } from "@nestjs/microservices";
import { ZBClient } from "zeebe-node-next";
/**
 * A customer transport for Zeebe.
 *
 * @export
 * @class ZeebeServer
 * @extends {Server}
 * @implements {CustomTransportStrategy}
 */
export declare class ZeebeServer extends Server implements CustomTransportStrategy {
    private readonly client;
    constructor(client: ZBClient);
    listen(callback: () => void): Promise<void>;
    close(): void;
    private init;
}
