"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var ZeebeModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const ZB = require("zeebe-node-next");
const core_1 = require("@nestjs/core");
const zeebe_constans_1 = require("./zeebe.constans");
let ZeebeModule = ZeebeModule_1 = class ZeebeModule {
    constructor(moduleRef) {
        this.moduleRef = moduleRef;
    }
    static forRoot(options) {
        const optionsProviders = [];
        const connectionProviders = [];
        optionsProviders.push(this.createOptionsProvider(options));
        connectionProviders.push(this.createConnectionProvider());
        return {
            module: ZeebeModule_1,
            providers: [...optionsProviders, ...connectionProviders],
            exports: connectionProviders,
        };
    }
    static forRootAsync(options) {
        const connectionProviders = [];
        connectionProviders.push(this.createConnectionProvider());
        return {
            module: ZeebeModule_1,
            imports: options.imports || [],
            providers: [
                {
                    provide: zeebe_constans_1.ZEEBE_OPTIONS_PROVIDER,
                    useFactory: options.useFactory,
                    inject: options.inject || [],
                },
                ...connectionProviders,
            ],
            exports: connectionProviders,
        };
    }
    static forFeature() {
        return {
            module: ZeebeModule_1,
        };
    }
    static createOptionsProvider(options) {
        return {
            provide: zeebe_constans_1.ZEEBE_OPTIONS_PROVIDER,
            useValue: options,
        };
    }
    static createConnectionProvider() {
        return {
            provide: zeebe_constans_1.ZEEBE_CONNECTION_PROVIDER,
            //TODO resolve host url: do I need to? Seems to work aready? Just verify
            useFactory: (config) => __awaiter(this, void 0, void 0, function* () { return new ZB.ZBClient(config.gatewayAddress, config.options); }),
            inject: [zeebe_constans_1.ZEEBE_OPTIONS_PROVIDER],
        };
    }
    onModuleDestroy() {
        common_1.Logger.error("Zeebe Module destroyed");
    }
};
ZeebeModule = ZeebeModule_1 = __decorate([
    common_1.Module({}),
    __metadata("design:paramtypes", [core_1.ModuleRef])
], ZeebeModule);
exports.ZeebeModule = ZeebeModule;
